/*
    Copyright (c) 2007 Cyrus Daboo. All rights reserved.
    
    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at
    
        http://www.apache.org/licenses/LICENSE-2.0
    
    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
*/

#ifndef __CCOMMAND_H
#define __CCOMMAND_H


class CCommand
{
	friend class CMainMenu;

public:

#define DECLARE_ENUM(name)	e##name,

enum
{
	// Menu commands
	eCommandsStart = 'Mlby',

	DECLARE_ENUM(FileNewMessage)
	DECLARE_ENUM(FileOpenMailbox)
	DECLARE_ENUM(FileOpenMessage)
	DECLARE_ENUM(FileOpenDraft)
	DECLARE_ENUM(FileImport)
	DECLARE_ENUM(FileExport)
	DECLARE_ENUM(FileClose)
	DECLARE_ENUM(FileSave)
	DECLARE_ENUM(FileSaveAs)
	DECLARE_ENUM(FileRevert)
	DECLARE_ENUM(FilePreferences)
	DECLARE_ENUM(FileDisconnect)
	DECLARE_ENUM(FileShowOutgoingQueues)
	DECLARE_ENUM(FilePageSetup)
	DECLARE_ENUM(FilePrint)
	DECLARE_ENUM(FileExit)
	
	DECLARE_ENUM(EditUndo)
	DECLARE_ENUM(EditRedo)
	DECLARE_ENUM(EditCut)
	DECLARE_ENUM(EditCopy)
	DECLARE_ENUM(EditPaste)
	DECLARE_ENUM(EditPasteAsQuote)
	DECLARE_ENUM(EditDelete)
	DECLARE_ENUM(EditSelectAll)
	DECLARE_ENUM(EditFind)
	DECLARE_ENUM(EditFindNext)
	DECLARE_ENUM(EditFindSel)
	DECLARE_ENUM(EditReplace)
	DECLARE_ENUM(EditReplaceFindNext)
	DECLARE_ENUM(EditReplaceAll)
	DECLARE_ENUM(EditTextMacros)
	DECLARE_ENUM(EditProperties)
	DECLARE_ENUM(EditChangePassword)
	DECLARE_ENUM(EditCheckSpelling)
	
	DECLARE_ENUM(EditOpenLink)		// Only used in context menu
	DECLARE_ENUM(EditCopyLink)		// Only used in context menu

	DECLARE_ENUM(MailboxCreate)
	DECLARE_ENUM(MailboxRename)
	DECLARE_ENUM(MailboxMarkContentsSeen)
	DECLARE_ENUM(MailboxDelete)
	DECLARE_ENUM(MailboxExpunge)
	DECLARE_ENUM(MailboxSynchronise)
	DECLARE_ENUM(MailboxClearDisconnected)
	DECLARE_ENUM(MailboxDisplayHierarchy)
		DECLARE_ENUM(DispHNew)
		DECLARE_ENUM(DispHEdit)
		DECLARE_ENUM(DispHRemove)
		DECLARE_ENUM(DispHReset)
		DECLARE_ENUM(DispHRefresh)
	DECLARE_ENUM(MailboxCabinets)
		DECLARE_ENUM(CabNew)
		DECLARE_ENUM(CabEdit)
		DECLARE_ENUM(CabRemove)
		DECLARE_ENUM(CabAddWild)
		DECLARE_ENUM(CabEditWild)
		DECLARE_ENUM(CabRemoveItem)
	DECLARE_ENUM(MailboxSubscribe)
	DECLARE_ENUM(MailboxUnsubscribe)
	DECLARE_ENUM(MailboxCheckMail)
	DECLARE_ENUM(MailboxCheckFavourites)
	DECLARE_ENUM(MailboxSortBy)
		DECLARE_ENUM(SortTo)
		DECLARE_ENUM(SortFrom)
		DECLARE_ENUM(SortReply)
		DECLARE_ENUM(SortSender)
		DECLARE_ENUM(SortCC)
		DECLARE_ENUM(SortSubject)
		DECLARE_ENUM(SortThread)
		DECLARE_ENUM(SortDateSent)
		DECLARE_ENUM(SortDateReceived)
		DECLARE_ENUM(SortSize)
		DECLARE_ENUM(SortFlags)
		DECLARE_ENUM(SortNumber)
		DECLARE_ENUM(SortSmartAddress)
		DECLARE_ENUM(SortAttachments)
		DECLARE_ENUM(SortParts)
		DECLARE_ENUM(SortMatching)
		DECLARE_ENUM(SortDisconnected)
	DECLARE_ENUM(MailboxGotoMessage)
	DECLARE_ENUM(MailboxLoadAllMessages)
	DECLARE_ENUM(MailboxUpdateMatch)
	DECLARE_ENUM(MailboxSearch)
	DECLARE_ENUM(MailboxSearchAgain)
	DECLARE_ENUM(MailboxNextSearch)
	DECLARE_ENUM(MailboxRules)
	DECLARE_ENUM(MailboxApplyRules)
	DECLARE_ENUM(MailboxMakeRule)

	DECLARE_ENUM(MessagesReadPrev)
	DECLARE_ENUM(MessagesReadNext)
	DECLARE_ENUM(MessagesDelAndReadNext)
	DECLARE_ENUM(MessagesCopyAndReadNext)
	DECLARE_ENUM(MessagesReply)
	DECLARE_ENUM(MessagesReplyToSender)
	DECLARE_ENUM(MessagesReplyToFrom)
	DECLARE_ENUM(MessagesReplyToAll)
	DECLARE_ENUM(MessagesForward)
	DECLARE_ENUM(MessagesBounce)
	DECLARE_ENUM(MessagesReject)
	DECLARE_ENUM(MessagesSendAgain)
	DECLARE_ENUM(MessagesCreateDigest)
	DECLARE_ENUM(MessagesCopyTo)
	DECLARE_ENUM(MessagesCopyNow)
	DECLARE_ENUM(MessagesFlags)
		DECLARE_ENUM(FlagsSeen)
		DECLARE_ENUM(FlagsImportant)
		DECLARE_ENUM(FlagsAnswered)
		DECLARE_ENUM(FlagsDeleted)
		DECLARE_ENUM(FlagsDraft)
		DECLARE_ENUM(FlagsLabel1)
		DECLARE_ENUM(FlagsLabel2)
		DECLARE_ENUM(FlagsLabel3)
		DECLARE_ENUM(FlagsLabel4)
		DECLARE_ENUM(FlagsLabel5)
		DECLARE_ENUM(FlagsLabel6)
		DECLARE_ENUM(FlagsLabel7)
		DECLARE_ENUM(FlagsLabel8)
	DECLARE_ENUM(MessagesViewParts)
	DECLARE_ENUM(MessagesExtractParts)
	DECLARE_ENUM(MessagesDecodeEmbedded)
		DECLARE_ENUM(DecodeBinHex)
		DECLARE_ENUM(DecodeUU)
	DECLARE_ENUM(MessagesVerifyDecrypt)
	DECLARE_ENUM(MessagesDelete)
	DECLARE_ENUM(MessagesShowHeader)

	DECLARE_ENUM(DraftIncludeOrig)
	DECLARE_ENUM(DraftInsertSig)
	DECLARE_ENUM(DraftAddCc)
	DECLARE_ENUM(DraftAddBcc)
	DECLARE_ENUM(DraftAttachFile)
	DECLARE_ENUM(DraftNewTextPart)
		DECLARE_ENUM(NewTextPlain)
		DECLARE_ENUM(NewTextEnriched)
		DECLARE_ENUM(NewTextHTML)
	DECLARE_ENUM(DraftNewMultipart)
		DECLARE_ENUM(NewMultiMixed)
		DECLARE_ENUM(NewMultiParallel)
		DECLARE_ENUM(NewMultiDigest)
		DECLARE_ENUM(NewMultiAlt)
	DECLARE_ENUM(DraftCurrentTextPart)
		DECLARE_ENUM(CurrentTextPlain)
		DECLARE_ENUM(CurrentTextPlainWrapped)
		DECLARE_ENUM(CurrentTextEnriched)
		DECLARE_ENUM(CurrentTextHTML)
	DECLARE_ENUM(DraftSend)
	DECLARE_ENUM(DraftAppendTo)
	DECLARE_ENUM(DraftAppendNow)
	DECLARE_ENUM(DraftCopyOriginal)
	DECLARE_ENUM(DraftSign)
	DECLARE_ENUM(DraftEncrypt)
	DECLARE_ENUM(DraftNotifications)
		DECLARE_ENUM(NotifyReceipt)
		DECLARE_ENUM(NotifySuccess)
		DECLARE_ENUM(NotifyFailure)
		DECLARE_ENUM(NotifyDelay)
		DECLARE_ENUM(NotifyEntireMsg)
	DECLARE_ENUM(DraftWrap)
	DECLARE_ENUM(DraftUnwrap)
	DECLARE_ENUM(DraftQuote)
	DECLARE_ENUM(DraftUnquote)
	DECLARE_ENUM(DraftRequote)
	DECLARE_ENUM(DraftShiftLeft)
	DECLARE_ENUM(DraftShiftRight)
	DECLARE_ENUM(DraftFont)
	DECLARE_ENUM(DraftSize)
	DECLARE_ENUM(DraftStyle)
		DECLARE_ENUM(StylePlain)
		DECLARE_ENUM(StyleBold)
		DECLARE_ENUM(StyleItalic)
		DECLARE_ENUM(StyleUnderline)
	DECLARE_ENUM(DraftAlignment)
		DECLARE_ENUM(AlignLeft)
		DECLARE_ENUM(AlignCenter)
		DECLARE_ENUM(AlignRight)
		DECLARE_ENUM(AlignJustified)
	DECLARE_ENUM(DraftColour)
		DECLARE_ENUM(ColourBlack)
		DECLARE_ENUM(ColourRed)
		DECLARE_ENUM(ColourGreen)
		DECLARE_ENUM(ColourBlue)
		DECLARE_ENUM(ColourYellow)
		DECLARE_ENUM(ColourCyan)
		DECLARE_ENUM(ColourMagenta)
		DECLARE_ENUM(ColourMulberry)
		DECLARE_ENUM(ColourWhite)
		DECLARE_ENUM(ColourOther)

	DECLARE_ENUM(AddressesAddBookMan)
	DECLARE_ENUM(AddressesNew)
	DECLARE_ENUM(AddressesOpen)
	DECLARE_ENUM(AddressesRename)
	DECLARE_ENUM(AddressesImport)
	DECLARE_ENUM(AddressesExport)
	DECLARE_ENUM(AddressesDelete)
	DECLARE_ENUM(AddressesLogin)
	DECLARE_ENUM(AddressesLogout)
	DECLARE_ENUM(AddressesRefresh)
	DECLARE_ENUM(AddressesSynchronise)
	DECLARE_ENUM(AddressesClearDisconnected)
	DECLARE_ENUM(AddressesExpandAddresses)
	DECLARE_ENUM(AddressesCaptureAddress)
	DECLARE_ENUM(AddressSearch)

	DECLARE_ENUM(CalendarManager)
	DECLARE_ENUM(CalendarSubscribe)
	DECLARE_ENUM(CalendarCreate)
	DECLARE_ENUM(CalendarRename)
	DECLARE_ENUM(CalendarCheck)
	DECLARE_ENUM(CalendarRefresh)
	DECLARE_ENUM(CalendarDelete)
	DECLARE_ENUM(CalendarAddWeb)
	DECLARE_ENUM(CalendarRefreshWeb)
	DECLARE_ENUM(CalendarUploadWeb)
	DECLARE_ENUM(CalendarNewEvent)
	DECLARE_ENUM(CalendarNewToDo)
	DECLARE_ENUM(CalendarEditItem)
	DECLARE_ENUM(CalendarDuplicateItem)
	DECLARE_ENUM(CalendarDeleteItem)
	DECLARE_ENUM(CalendarGotoToday)
	DECLARE_ENUM(CalendarGotoDate)

	DECLARE_ENUM(WindowsCascade)
	DECLARE_ENUM(WindowsTileHor)
	DECLARE_ENUM(WindowsTileVert)
	DECLARE_ENUM(WindowsSaveDefault)
	DECLARE_ENUM(WindowsResetToDefault)
	DECLARE_ENUM(WindowsExpandHeader)
	DECLARE_ENUM(WindowsShowParts)
	DECLARE_ENUM(WindowsShowQuickSearch)
	DECLARE_ENUM(WindowsToolbars)
		DECLARE_ENUM(ToolbarsButtons)
		DECLARE_ENUM(ToolbarsSmall)
		DECLARE_ENUM(ToolbarsIcons)
		DECLARE_ENUM(ToolbarsCaptions)
		DECLARE_ENUM(ToolbarsBoth)
	DECLARE_ENUM(WindowsLayout)
		DECLARE_ENUM(Layout3Pane)
		DECLARE_ENUM(LayoutSingle)
		DECLARE_ENUM(LayoutListVert)
		DECLARE_ENUM(LayoutListHoriz)
		DECLARE_ENUM(LayoutItemsVert)
		DECLARE_ENUM(LayoutItemsHoriz)
		DECLARE_ENUM(LayoutPreviewVert)
		DECLARE_ENUM(LayoutPreviewHoriz)
		DECLARE_ENUM(LayoutAllVert)
		DECLARE_ENUM(LayoutAllHoriz)
	DECLARE_ENUM(WindowsShowList)
	DECLARE_ENUM(WindowsShowItems)
	DECLARE_ENUM(WindowsShowPreview)
	DECLARE_ENUM(WindowsOptions)
	DECLARE_ENUM(WindowsStatus)
	DECLARE_ENUM(WindowsDynamicStart)

	DECLARE_ENUM(HelpHelpTopics)
	DECLARE_ENUM(HelpAboutMul)
	DECLARE_ENUM(HelpAboutPlugins)
	DECLARE_ENUM(HelpDetailedTooltips)
	DECLARE_ENUM(HelpMulberryOnline)
	DECLARE_ENUM(HelpMulberryFAQ)
	DECLARE_ENUM(HelpMulberryUpdates)
	DECLARE_ENUM(HelpMulberrySupport)

	// Hidden commands - probably in context menu only
	DECLARE_ENUM(AddressNew)
	DECLARE_ENUM(AddressEdit)
	DECLARE_ENUM(AddressDelete)
	DECLARE_ENUM(AddressNewMessage)

	DECLARE_ENUM(CalendarNewMessage)
	DECLARE_ENUM(CalendarFreeBusy)
	DECLARE_ENUM(CalendarInvite)
	DECLARE_ENUM(CalendarCompleted)

	DECLARE_ENUM(RulesNew)
	DECLARE_ENUM(RulesEdit)
	DECLARE_ENUM(RulesDelete)
	DECLARE_ENUM(RulesWriteScript)

	// Common toolbar
	DECLARE_ENUM(ToolbarNewLetter)
	DECLARE_ENUM(ToolbarNewLetterOption)
	DECLARE_ENUM(ToolbarDetailsBtn)
	DECLARE_ENUM(ToolbarMailboxExpungeBtn)
	DECLARE_ENUM(ToolbarSearchMailboxBtn)
	DECLARE_ENUM(ToolbarMessageReplyBtn)
	DECLARE_ENUM(ToolbarMessageReplyOptionBtn)
	DECLARE_ENUM(ToolbarMessageReplyAllBtn)
	DECLARE_ENUM(ToolbarMessageForwardBtn)
	DECLARE_ENUM(ToolbarMessageForwardOptionBtn)
	DECLARE_ENUM(ToolbarMessageBounceBtn)
	DECLARE_ENUM(ToolbarMessageRejectBtn)
	DECLARE_ENUM(ToolbarMessageSendAgainBtn)
	DECLARE_ENUM(ToolbarMessageDigestBtn)
	DECLARE_ENUM(ToolbarMessageCopyBtn)
	DECLARE_ENUM(ToolbarMessageCopyOptionBtn)
	DECLARE_ENUM(ToolbarMessageCopyPopup)
	DECLARE_ENUM(ToolbarMessageCopyOptionPopup)
	DECLARE_ENUM(ToolbarMessageDeleteBtn)
	DECLARE_ENUM(ToolbarMessageHeaderBtn)
	DECLARE_ENUM(ToolbarFileSaveBtn)
	DECLARE_ENUM(ToolbarMessagePrintBtn)
	
	// 3 pane toolbar
	DECLARE_ENUM(ToolbarZoomList)
	DECLARE_ENUM(ToolbarZoomItems)
	DECLARE_ENUM(ToolbarZoomPreview)
	DECLARE_ENUM(ToolbarCloseList)
	DECLARE_ENUM(ToolbarCloseItems)
	DECLARE_ENUM(ToolbarClosePreview)
	DECLARE_ENUM(ToolbarShowList)
	DECLARE_ENUM(ToolbarShowItems)
	DECLARE_ENUM(ToolbarShowPreview)
	
	// Server toolbar
	DECLARE_ENUM(ToolbarServerLoginBtn)
	DECLARE_ENUM(ToolbarCreateMailboxBtn)
	DECLARE_ENUM(ToolbarCheckMailboxBtn)
	DECLARE_ENUM(ToolbarCabinetPopup)

	// Mailbox toolbar
	DECLARE_ENUM(ToolbarMailboxMatchBtn)
	DECLARE_ENUM(ToolbarMailboxMatchOptionBtn)
	DECLARE_ENUM(ToolbarMailboxSelectPopup)
	DECLARE_ENUM(ToolbarMailboxApplyRules)

	// SMTP toolbar
	DECLARE_ENUM(ToolbarSMTPHoldBtn)
	DECLARE_ENUM(ToolbarSMTPPriorityBtn)
	DECLARE_ENUM(ToolbarSMTPAccountsPopup)
	DECLARE_ENUM(ToolbarSMTPEnableBtn)

	// Message toolbar
	DECLARE_ENUM(ToolbarMessageFlagsBtn)
	DECLARE_ENUM(ToolbarMessageDeleteNextBtn)
	DECLARE_ENUM(ToolbarMessagePreviousBtn)
	DECLARE_ENUM(ToolbarMessageNextBtn)

	// Letter toolbar
	DECLARE_ENUM(ToolbarLetterAttachBtn)
	DECLARE_ENUM(ToolbarLetterSpellBtn)
	DECLARE_ENUM(ToolbarLetterReceiptBtn)
	DECLARE_ENUM(ToolbarLetterDSNBtn)
	DECLARE_ENUM(ToolbarLetterSignatureBtn)
	DECLARE_ENUM(ToolbarLetterSignBtn)
	DECLARE_ENUM(ToolbarLetterEncryptBtn)
	DECLARE_ENUM(ToolbarLetterSendBtn)
	DECLARE_ENUM(ToolbarLetterAddCcBtn)
	DECLARE_ENUM(ToolbarLetterAddBccBtn)
	DECLARE_ENUM(ToolbarLetterAppendNowBtn)
	DECLARE_ENUM(ToolbarLetterCopyOriginalBtn)
	DECLARE_ENUM(ToolbarLetterExternalBtn)
	DECLARE_ENUM(ToolbarWindowsExpandHeaderBtn)

	// Address Book Manager toolbar
	DECLARE_ENUM(ToolbarAdbkMgrNewBtn)
	DECLARE_ENUM(ToolbarAdbkMgrOpenBtn)
	DECLARE_ENUM(ToolbarAdbkMgrDeleteBtn)
	DECLARE_ENUM(ToolbarAdbkMgrSearchBtn)
	DECLARE_ENUM(ToolbarAdbkMgrPropertiesBtn)

	// Address Book toolbar
	DECLARE_ENUM(ToolbarAddressBookAddressBtn)
	DECLARE_ENUM(ToolbarAddressBookGroupBtn)
	DECLARE_ENUM(ToolbarAddressBookEditBtn)
	DECLARE_ENUM(ToolbarAddressBookDeleteBtn)
	
	// Calendar toolbar
	DECLARE_ENUM(ToolbarCalendarCreateBtn)
	DECLARE_ENUM(ToolbarCalendarNewEventBtn)
	DECLARE_ENUM(ToolbarCalendarNewToDoBtn)
	DECLARE_ENUM(ToolbarCalendarCheckBtn)
	DECLARE_ENUM(ToolbarCalendarTodayBtn)
	DECLARE_ENUM(ToolbarCalendarGotoBtn)
	DECLARE_ENUM(ToolbarCalendarDayBtn)
	DECLARE_ENUM(ToolbarCalendarWorkBtn)
	DECLARE_ENUM(ToolbarCalendarWeekBtn)
	DECLARE_ENUM(ToolbarCalendarMonthBtn)
	DECLARE_ENUM(ToolbarCalendarYearBtn)
	DECLARE_ENUM(ToolbarCalendarSummaryBtn)
	DECLARE_ENUM(ToolbarCalendarTasksBtn)

	// Explicit commands
	DECLARE_ENUM(CommandMessageCopy)
	DECLARE_ENUM(CommandMessageMove)
	
	DECLARE_ENUM(CommandMailboxThreadAll)
	DECLARE_ENUM(CommandMailboxThreadMarkSeen)
	DECLARE_ENUM(CommandMailboxThreadMarkImportant)
	DECLARE_ENUM(CommandMailboxThreadMarkDeleted)
	DECLARE_ENUM(CommandMailboxThreadSkip)
	
	DECLARE_ENUM(CommandMailboxMatchUnseen)
	DECLARE_ENUM(CommandMailboxMatchImportant)
	DECLARE_ENUM(CommandMailboxMatchDeleted)
	DECLARE_ENUM(CommandMailboxMatchSentToday)
	DECLARE_ENUM(CommandMailboxMatchFrom)
	DECLARE_ENUM(CommandMailboxMatchSubject)
	DECLARE_ENUM(CommandMailboxMatchDate)

	eCommandLast
};

#define DECLARE_STR(name)	static const char* c##name;

	DECLARE_STR(FileNewMessage)
	DECLARE_STR(FileOpenMailbox)
	DECLARE_STR(FileOpenMessage)
	DECLARE_STR(FileOpenDraft)
	DECLARE_STR(FileImport)
	DECLARE_STR(FileExport)
	DECLARE_STR(FileClose)
	DECLARE_STR(FileSave)
	DECLARE_STR(FileSaveAs)
	DECLARE_STR(FileRevert)
	DECLARE_STR(FilePreferences)
	DECLARE_STR(FileDisconnect)
	DECLARE_STR(FileShowOutgoingQueues)
	DECLARE_STR(FilePageSetup)
	DECLARE_STR(FilePrint)
	DECLARE_STR(FileExit)
	
	DECLARE_STR(EditUndo)
	DECLARE_STR(EditRedo)
	DECLARE_STR(EditCut)
	DECLARE_STR(EditCopy)
	DECLARE_STR(EditPaste)
	DECLARE_STR(EditPasteAsQuote)
	DECLARE_STR(EditDelete)
	DECLARE_STR(EditSelectAll)
	DECLARE_STR(EditFind)
	DECLARE_STR(EditFindNext)
	DECLARE_STR(EditFindSel)
	DECLARE_STR(EditReplace)
	DECLARE_STR(EditReplaceFindNext)
	DECLARE_STR(EditReplaceAll)
	DECLARE_STR(EditTextMacros)
	DECLARE_STR(EditProperties)
	DECLARE_STR(EditChangePassword)
	DECLARE_STR(EditCheckSpelling)

	DECLARE_STR(EditOpenLink)
	DECLARE_STR(EditCopyLink)

	DECLARE_STR(MailboxCreate)
	DECLARE_STR(MailboxRename)
	DECLARE_STR(MailboxMarkContentsSeen)
	DECLARE_STR(MailboxDelete)
	DECLARE_STR(MailboxExpunge)
	DECLARE_STR(MailboxSynchronise)
	DECLARE_STR(MailboxClearDisconnected)
	DECLARE_STR(MailboxDisplayHierarchy)
		DECLARE_STR(DispHNew)
		DECLARE_STR(DispHEdit)
		DECLARE_STR(DispHRemove)
		DECLARE_STR(DispHReset)
		DECLARE_STR(DispHRefresh)
	DECLARE_STR(MailboxCabinets)
		DECLARE_STR(CabNew)
		DECLARE_STR(CabEdit)
		DECLARE_STR(CabRemove)
		DECLARE_STR(CabAddWild)
		DECLARE_STR(CabEditWild)
		DECLARE_STR(CabRemoveItem)
	DECLARE_STR(MailboxSubscribe)
	DECLARE_STR(MailboxUnsubscribe)
	DECLARE_STR(MailboxCheckMail)
	DECLARE_STR(MailboxCheckFavourites)
	DECLARE_STR(MailboxSortBy)
		DECLARE_STR(SortTo)
		DECLARE_STR(SortFrom)
		DECLARE_STR(SortReply)
		DECLARE_STR(SortSender)
		DECLARE_STR(SortCC)
		DECLARE_STR(SortSubject)
		DECLARE_STR(SortThread)
		DECLARE_STR(SortDateSent)
		DECLARE_STR(SortDateReceived)
		DECLARE_STR(SortSize)
		DECLARE_STR(SortFlags)
		DECLARE_STR(SortNumber)
		DECLARE_STR(SortSmartAddress)
		DECLARE_STR(SortAttachments)
		DECLARE_STR(SortParts)
		DECLARE_STR(SortMatching)
		DECLARE_STR(SortDisconnected)
	DECLARE_STR(MailboxGotoMessage)
	DECLARE_STR(MailboxLoadAllMessages)
	DECLARE_STR(MailboxUpdateMatch)
	DECLARE_STR(MailboxSearch)
	DECLARE_STR(MailboxSearchAgain)
	DECLARE_STR(MailboxNextSearch)
	DECLARE_STR(MailboxRules)
	DECLARE_STR(MailboxApplyRules)
	DECLARE_STR(MailboxMakeRule)

	DECLARE_STR(MessagesReadPrev)
	DECLARE_STR(MessagesReadNext)
	DECLARE_STR(MessagesDelAndReadNext)
	DECLARE_STR(MessagesCopyAndReadNext)
	DECLARE_STR(MessagesReply)
	DECLARE_STR(MessagesReplyToSender)
	DECLARE_STR(MessagesReplyToFrom)
	DECLARE_STR(MessagesReplyToAll)
	DECLARE_STR(MessagesForward)
	DECLARE_STR(MessagesBounce)
	DECLARE_STR(MessagesReject)
	DECLARE_STR(MessagesSendAgain)
	DECLARE_STR(MessagesCreateDigest)
	DECLARE_STR(MessagesCopyTo)
	DECLARE_STR(MessagesCopyNow)
	DECLARE_STR(MessagesFlags)
		DECLARE_STR(FlagsSeen)
		DECLARE_STR(FlagsImportant)
		DECLARE_STR(FlagsAnswered)
		DECLARE_STR(FlagsDeleted)
		DECLARE_STR(FlagsDraft)
		DECLARE_STR(FlagsLabel1)
		DECLARE_STR(FlagsLabel2)
		DECLARE_STR(FlagsLabel3)
		DECLARE_STR(FlagsLabel4)
		DECLARE_STR(FlagsLabel5)
		DECLARE_STR(FlagsLabel6)
		DECLARE_STR(FlagsLabel7)
		DECLARE_STR(FlagsLabel8)
	DECLARE_STR(MessagesViewParts)
	DECLARE_STR(MessagesExtractParts)
	DECLARE_STR(MessagesDecodeEmbedded)
		DECLARE_STR(DecodeBinHex)
		DECLARE_STR(DecodeUU)
	DECLARE_STR(MessagesVerifyDecrypt)
	DECLARE_STR(MessagesDelete)
	DECLARE_STR(MessagesShowHeader)

	DECLARE_STR(DraftIncludeOrig)
	DECLARE_STR(DraftInsertSig)
	DECLARE_STR(DraftAddCc)
	DECLARE_STR(DraftAddBcc)
	DECLARE_STR(DraftAttachFile)
	DECLARE_STR(DraftNewTextPart)
		DECLARE_STR(NewTextPlain)
		DECLARE_STR(NewTextEnriched)
		DECLARE_STR(NewTextHTML)
	DECLARE_STR(DraftNewMultipart)
		DECLARE_STR(NewMultiMixed)
		DECLARE_STR(NewMultiParallel)
		DECLARE_STR(NewMultiDigest)
		DECLARE_STR(NewMultiAlt)
	DECLARE_STR(DraftCurrentTextPart)
		DECLARE_STR(CurrentTextPlain)
		DECLARE_STR(CurrentTextPlainWrapped)
		DECLARE_STR(CurrentTextEnriched)
		DECLARE_STR(CurrentTextHTML)
	DECLARE_STR(DraftSend)
	DECLARE_STR(DraftAppendTo)
	DECLARE_STR(DraftAppendNow)
	DECLARE_STR(DraftCopyOriginal)
	DECLARE_STR(DraftSign)
	DECLARE_STR(DraftEncrypt)
	DECLARE_STR(DraftNotifications)
		DECLARE_STR(NotifyReceipt)
		DECLARE_STR(NotifySuccess)
		DECLARE_STR(NotifyFailure)
		DECLARE_STR(NotifyDelay)
		DECLARE_STR(NotifyEntireMsg)
	DECLARE_STR(DraftWrap)
	DECLARE_STR(DraftUnwrap)
	DECLARE_STR(DraftQuote)
	DECLARE_STR(DraftUnquote)
	DECLARE_STR(DraftRequote)
	DECLARE_STR(DraftShiftLeft)
	DECLARE_STR(DraftShiftRight)
	DECLARE_STR(DraftFont)
	DECLARE_STR(DraftSize)
	DECLARE_STR(DraftStyle)
		DECLARE_STR(StylePlain)
		DECLARE_STR(StyleBold)
		DECLARE_STR(StyleItalic)
		DECLARE_STR(StyleUnderline)
	DECLARE_STR(DraftAlignment)
		DECLARE_STR(AlignLeft)
		DECLARE_STR(AlignCenter)
		DECLARE_STR(AlignRight)
		DECLARE_STR(AlignJustified)
	DECLARE_STR(DraftColour)
		DECLARE_STR(ColourBlack)
		DECLARE_STR(ColourRed)
		DECLARE_STR(ColourGreen)
		DECLARE_STR(ColourBlue)
		DECLARE_STR(ColourYellow)
		DECLARE_STR(ColourCyan)
		DECLARE_STR(ColourMagenta)
		DECLARE_STR(ColourMulberry)
		DECLARE_STR(ColourWhite)
		DECLARE_STR(ColourOther)

	DECLARE_STR(AddressesAddBookMan)
	DECLARE_STR(AddressesNew)
	DECLARE_STR(AddressesOpen)
	DECLARE_STR(AddressesRename)
	DECLARE_STR(AddressesImport)
	DECLARE_STR(AddressesExport)
	DECLARE_STR(AddressesDelete)
	DECLARE_STR(AddressesLogin)
	DECLARE_STR(AddressesLogout)
	DECLARE_STR(AddressesRefresh)
	DECLARE_STR(AddressesSynchronise)
	DECLARE_STR(AddressesClearDisconnected)
	DECLARE_STR(AddressesExpandAddresses)
	DECLARE_STR(AddressesCaptureAddress)
	DECLARE_STR(AddressSearch)

	DECLARE_STR(CalendarManager)
	DECLARE_STR(CalendarSubscribe)
	DECLARE_STR(CalendarCreate)
	DECLARE_STR(CalendarRename)
	DECLARE_STR(CalendarCheck)
	DECLARE_STR(CalendarRefresh)
	DECLARE_STR(CalendarDelete)
	DECLARE_STR(CalendarAddWeb)
	DECLARE_STR(CalendarRefreshWeb)
	DECLARE_STR(CalendarUploadWeb)
	DECLARE_STR(CalendarNewEvent)
	DECLARE_STR(CalendarNewToDo)
	DECLARE_STR(CalendarEditItem)
	DECLARE_STR(CalendarDuplicateItem)
	DECLARE_STR(CalendarDeleteItem)
	DECLARE_STR(CalendarGotoToday)
	DECLARE_STR(CalendarGotoDate)

	DECLARE_STR(WindowsCascade)
	DECLARE_STR(WindowsTileHor)
	DECLARE_STR(WindowsTileVert)
	DECLARE_STR(WindowsSaveDefault)
	DECLARE_STR(WindowsResetToDefault)
	DECLARE_STR(WindowsExpandHeader)
	DECLARE_STR(WindowsShowParts)
	DECLARE_STR(WindowsShowQuickSearch)
	DECLARE_STR(WindowsToolbars)
		DECLARE_STR(ToolbarsButtons)
		DECLARE_STR(ToolbarsSmall)
		DECLARE_STR(ToolbarsIcons)
		DECLARE_STR(ToolbarsCaptions)
		DECLARE_STR(ToolbarsBoth)
	DECLARE_STR(WindowsLayout)
		DECLARE_STR(Layout3Pane)
		DECLARE_STR(LayoutSingle)
		DECLARE_STR(LayoutListVert)
		DECLARE_STR(LayoutListHoriz)
		DECLARE_STR(LayoutItemsVert)
		DECLARE_STR(LayoutItemsHoriz)
		DECLARE_STR(LayoutPreviewVert)
		DECLARE_STR(LayoutPreviewHoriz)
		DECLARE_STR(LayoutAllVert)
		DECLARE_STR(LayoutAllHoriz)
	DECLARE_STR(WindowsShowList)
	DECLARE_STR(WindowsShowItems)
	DECLARE_STR(WindowsShowPreview)
	DECLARE_STR(WindowsOptions)
	DECLARE_STR(WindowsStatus)
	DECLARE_STR(WindowsDynamicStart)

	DECLARE_STR(HelpHelpTopics)
	DECLARE_STR(HelpAboutMul)
	DECLARE_STR(HelpAboutPlugins)
	DECLARE_STR(HelpDetailedTooltips)
	DECLARE_STR(HelpMulberryOnline)
	DECLARE_STR(HelpMulberryFAQ)
	DECLARE_STR(HelpMulberryUpdates)
	DECLARE_STR(HelpMulberrySupport)

	DECLARE_STR(AddressNew)
	DECLARE_STR(AddressEdit)
	DECLARE_STR(AddressDelete)
	DECLARE_STR(AddressNewMessage)

	DECLARE_STR(CalendarNewMessage)
	DECLARE_STR(CalendarFreeBusy)
	DECLARE_STR(CalendarInvite)
	DECLARE_STR(CalendarCompleted)

	DECLARE_STR(RulesNew)
	DECLARE_STR(RulesEdit)
	DECLARE_STR(RulesDelete)
	DECLARE_STR(RulesWriteScript)

	// Common toolbar
	DECLARE_STR(ToolbarNewLetter)
	DECLARE_STR(ToolbarNewLetterOption)
	DECLARE_STR(ToolbarDetailsBtn)
	DECLARE_STR(ToolbarMailboxExpungeBtn)
	DECLARE_STR(ToolbarSearchMailboxBtn)
	DECLARE_STR(ToolbarMessageReplyBtn)
	DECLARE_STR(ToolbarMessageReplyOptionBtn)
	DECLARE_STR(ToolbarMessageForwardBtn)
	DECLARE_STR(ToolbarMessageForwardOptionBtn)
	DECLARE_STR(ToolbarMessageBounceBtn)
	DECLARE_STR(ToolbarMessageRejectBtn)
	DECLARE_STR(ToolbarMessageSendAgainBtn)
	DECLARE_STR(ToolbarMessageDigestBtn)
	DECLARE_STR(ToolbarMessageCopyBtn)
	DECLARE_STR(ToolbarMessageCopyOptionBtn)
	DECLARE_STR(ToolbarMessageCopyPopup)
	DECLARE_STR(ToolbarMessageCopyOptionPopup)
	DECLARE_STR(ToolbarMessageDeleteBtn)
	DECLARE_STR(ToolbarMessageHeaderBtn)
	DECLARE_STR(ToolbarFileSaveBtn)
	DECLARE_STR(ToolbarMessagePrintBtn)

	// 3 pane toolbar
	DECLARE_STR(ToolbarZoomList)
	DECLARE_STR(ToolbarZoomItems)
	DECLARE_STR(ToolbarZoomPreview)
	DECLARE_STR(ToolbarCloseList)
	DECLARE_STR(ToolbarCloseItems)
	DECLARE_STR(ToolbarClosePreview)
	DECLARE_STR(ToolbarShowList)
	DECLARE_STR(ToolbarShowItems)
	DECLARE_STR(ToolbarShowPreview)

	// Server toolbar
	DECLARE_STR(ToolbarServerLoginBtn)
	DECLARE_STR(ToolbarCreateMailboxBtn)
	DECLARE_STR(ToolbarCheckMailboxBtn)
	DECLARE_STR(ToolbarCabinetPopup)

	// Mailbox toolbar
	DECLARE_STR(ToolbarMailboxMatchBtn)
	DECLARE_STR(ToolbarMailboxMatchOptionBtn)
	DECLARE_STR(ToolbarMailboxSelectPopup)
	DECLARE_STR(ToolbarMailboxApplyRules)

	// SMTP toolbar
	DECLARE_STR(ToolbarSMTPHoldBtn)
	DECLARE_STR(ToolbarSMTPPriorityBtn)
	DECLARE_STR(ToolbarSMTPAccountsPopup)
	DECLARE_STR(ToolbarSMTPEnableBtn)

	// Message toolbar
	DECLARE_STR(ToolbarMessageFlagsBtn)
	DECLARE_STR(ToolbarMessageDeleteNextBtn)
	DECLARE_STR(ToolbarMessagePreviousBtn)
	DECLARE_STR(ToolbarMessageNextBtn)

	// Letter toolbar
	DECLARE_STR(ToolbarLetterAttachBtn)
	DECLARE_STR(ToolbarLetterSpellBtn)
	DECLARE_STR(ToolbarLetterReceiptBtn)
	DECLARE_STR(ToolbarLetterDSNBtn)
	DECLARE_STR(ToolbarLetterSignatureBtn)
	DECLARE_STR(ToolbarLetterSignBtn)
	DECLARE_STR(ToolbarLetterEncryptBtn)
	DECLARE_STR(ToolbarLetterSendBtn)
	DECLARE_STR(ToolbarLetterAddCcBtn)
	DECLARE_STR(ToolbarLetterAddBccBtn)
	DECLARE_STR(ToolbarLetterAppendNowBtn)
	DECLARE_STR(ToolbarLetterCopyOriginalBtn)
	DECLARE_STR(ToolbarLetterExternalBtn)
	DECLARE_STR(ToolbarWindowsExpandHeaderBtn)

	// Address Book Manager toolbar
	DECLARE_STR(ToolbarAdbkMgrNewBtn)
	DECLARE_STR(ToolbarAdbkMgrOpenBtn)
	DECLARE_STR(ToolbarAdbkMgrDeleteBtn)
	DECLARE_STR(ToolbarAdbkMgrSearchBtn)
	DECLARE_STR(ToolbarAdbkMgrPropertiesBtn)

	// Address Book toolbar
	DECLARE_STR(ToolbarAddressBookAddressBtn)
	DECLARE_STR(ToolbarAddressBookGroupBtn)
	DECLARE_STR(ToolbarAddressBookEditBtn)
	DECLARE_STR(ToolbarAddressBookDeleteBtn)

	// Calendar toolbar
	DECLARE_STR(ToolbarCalendarCreateBtn)
	DECLARE_STR(ToolbarCalendarNewEventBtn)
	DECLARE_STR(ToolbarCalendarNewToDoBtn)
	DECLARE_STR(ToolbarCalendarCheckBtn)
	DECLARE_STR(ToolbarCalendarTodayBtn)
	DECLARE_STR(ToolbarCalendarGotoBtn)
	DECLARE_STR(ToolbarCalendarDayBtn)
	DECLARE_STR(ToolbarCalendarWorkBtn)
	DECLARE_STR(ToolbarCalendarWeekBtn)
	DECLARE_STR(ToolbarCalendarMonthBtn)
	DECLARE_STR(ToolbarCalendarYearBtn)
	DECLARE_STR(ToolbarCalendarSummaryBtn)
	DECLARE_STR(ToolbarCalendarTasksBtn)

	// Explicit commands
	DECLARE_STR(CommandMessageCopy)
	DECLARE_STR(CommandMessageMove)

	DECLARE_STR(CommandMailboxThreadAll)
	DECLARE_STR(CommandMailboxThreadMarkSeen)
	DECLARE_STR(CommandMailboxThreadMarkImportant)
	DECLARE_STR(CommandMailboxThreadMarkDeleted)
	DECLARE_STR(CommandMailboxThreadSkip)
	
	DECLARE_STR(CommandMailboxMatchUnseen)
	DECLARE_STR(CommandMailboxMatchImportant)
	DECLARE_STR(CommandMailboxMatchDeleted)
	DECLARE_STR(CommandMailboxMatchSentToday)
	DECLARE_STR(CommandMailboxMatchFrom)
	DECLARE_STR(CommandMailboxMatchSubject)
	DECLARE_STR(CommandMailboxMatchDate)

	static unsigned long CommandToCmd(const char* cmdname);
};
	 
#endif
