/*
    Copyright (c) 2007 Cyrus Daboo. All rights reserved.
    
    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at
    
        http://www.apache.org/licenses/LICENSE-2.0
    
    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
*/


#include "CHTMLCharacterEntity.h"

const long cStartCharacterEntity = 161;
const SMapHTML cHTMLCharacterEntity[] = {
						{"amp", '&'},
						{"lt", '<'},
						{"gt", '>'},
						{"quot", '\"'},
						
						// Latin-1
						{"nbsp", ' '},
						{"iexcl", 161},
						{"cent", 162},
						{"pound", 163},
						{"curren", 164},
						{"yen", 165},
						{"brvbar", 166},
						{"sect", 167},
						{"uml", 168},
						{"copy", 169},
						{"ordf", 170},
						{"laquo", 171},
						{"not", 172},
						{"shy", 173},
						{"reg", 174},
						{"macr", 175},
						{"deg", 176},
						{"plusmn", 177},
						{"sup2", 178},
						{"sup3", 179},
						{"acute", 180},
						{"micro", 181},
						{"para", 182},
						{"middot", 183},
						{"cedil", 184},
						{"sup1", 185},
						{"ordm", 186},
						{"raquo", 187},
						{"frac14", 188},
						{"frac12", 189},
						{"frac34", 190},
						{"iquest", 191},
						{"Agrave", 192},
						{"Aacute", 193},
						{"Acirc", 194},
						{"Atilde", 195},
						{"Auml", 196},
						{"Aring", 197},
						{"AElig", 198},
						{"Ccedil", 199},
						{"Egrave", 200},
						{"Eacute", 201},
						{"Ecirc", 202},
						{"Euml", 203},
						{"Igrave", 204},
						{"Iacute", 205},
						{"Icirc", 206},
						{"Iuml", 207},
						{"ETH", 208},
						{"Ntilde", 209},
						{"Ograve", 210},
						{"Oacute", 211},
						{"Ocirc", 212},
						{"Otilde", 213},
						{"Ouml", 214},
						{"times", 215},
						{"Oslash", 216},
						{"Ugrave", 217},
						{"Uacute", 218},
						{"Ucirc", 219},
						{"Uuml", 220},
						{"Yacute", 221},
						{"THORN", 222},
						{"szlig", 223},
						{"agrave", 224},
						{"aacute", 225},
						{"acirc", 226},
						{"atilde", 227},
						{"auml", 228},
						{"aring", 229},
						{"aelig", 230},
						{"ccedil", 231},
						{"egrave", 232},
						{"eacute", 233},
						{"ecirc", 234},
						{"euml", 235},
						{"igrave", 236},
						{"iacute", 237},
						{"icirc", 238},
						{"iuml", 239},
						{"eth", 240},
						{"ntilde", 241},
						{"ograve", 242},
						{"oacute", 243},
						{"ocirc", 244},
						{"otilde", 245},
						{"ouml", 246},
						{"oslash", 248},
						{"ugrave", 249},
						{"uacute", 250},
						{"ucirc", 251},
						{"uuml", 252},
						{"yacute", 253},
						{"thorn", 254},
						{"yuml", 255},

						// Latin Extended-A
						{"OElig", 338},
						{"oelig", 339},
						{"Scaron", 352},
						{"scaron", 353},
						{"Yuml", 376},

						// Latin Extended-B
						{"fnof", 402},

						// Spacing Modifier Letters
						{"circ", 710},
						{"tilde", 732},

						// Greek
						{"Alpha", 913},
						{"Beta", 914},
						{"Gamma", 915},
						{"Delta", 916},
						{"Epsilon", 917},
						{"Zeta", 918},
						{"Eta", 919},
						{"Theta", 920},
						{"Iota", 921},
						{"Kappa", 922},
						{"Lambda", 923},
						{"Mu", 924},
						{"Nu", 925},
						{"Xi", 926},
						{"Omicron", 927},
						{"Pi", 928},
						{"Rho", 929},
						{"Sigma", 931},
						{"Tau", 932},
						{"Upsilon", 933},
						{"Phi", 934},
						{"Chi", 935},
						{"Psi", 936},
						{"Omega", 937},
						{"alpha", 945},
						{"beta", 946},
						{"gamma", 947},
						{"delta", 948},
						{"epsilon", 949},
						{"zeta", 950},
						{"eta", 951},
						{"theta", 952},
						{"iota", 953},
						{"kappa", 954},
						{"lambda", 955},
						{"mu", 956},
						{"nu", 957},
						{"xi", 958},
						{"omicron", 959},
						{"pi", 960},
						{"rho", 961},
						{"sigmaf", 962},
						{"sigma", 963},
						{"tau", 964},
						{"upsilon", 965},
						{"phi", 966},
						{"chi", 967},
						{"psi", 968},
						{"omega", 969},
						{"thetasym", 977},
						{"upsih", 978},
						{"piv", 982},

						// General Punctuation
						{"ensp", 8194},
						{"emsp", 8195},
						{"thinsp", 8201},
						{"zwnj", 8204},
						{"zwj", 8205},
						{"lrm", 8206},
						{"rlm", 8207},
						{"ndash", 8211},
						{"mdash", 8212},
						{"lsquo", 8216},
						{"rsquo", 8217},
						{"sbquo", 8218},
						{"ldquo", 8220},
						{"rdquo", 8221},
						{"bdquo", 8222},
						{"dagger", 8224},
						{"Dagger", 8225},
						{"bull", 8226},
						{"hellip", 8230},
						{"permil", 8240},
						{"prime", 8242},
						{"Prime", 8243},
						{"lsaquo", 8249},
						{"rsaquo", 8250},
						{"oline", 8254},
						{"frasl", 8260},

						{"euro", 8364},

						// Letterlike Symbols
						{"weierp", 8472},
						{"image", 8465},
						{"real", 8476},
						{"trade", 8482},
						{"alefsym", 8501},

						// Arrows
						{"larr", 8592},
						{"uarr", 8593},
						{"rarr", 8594},
						{"darr", 8595},
						{"harr", 8596},
						{"crarr", 8629},
						{"lArr", 8656},
						{"uArr", 8657},
						{"rArr", 8658},
						{"dArr", 8659},
						{"hArr", 8660},

						// Mathematical Operators
						{"forall", 8704},
						{"part", 8706},
						{"exist", 8707},
						{"empty", 8709},
						{"nabla", 8711},
						{"isin", 8712},
						{"notin", 8713},
						{"ni", 8715},
						{"prod", 8719},
						{"sum", 8721},
						{"minus", 8722},
						{"lowast", 8727},
						{"radic", 8730},
						{"prop", 8733},
						{"infin", 8734},
						{"ang", 8736},
						{"and", 8743},
						{"or", 8744},
						{"cap", 8745},
						{"cup", 8746},
						{"int", 8747},
						{"there4", 8756},
						{"sim", 8764},
						{"cong", 8773},
						{"asymp", 8776},
						{"ne", 8800},
						{"equiv", 8801},
						{"le", 8804},
						{"ge", 8805},
						{"sub", 8834},
						{"sup", 8835},
						{"nsub", 8836},
						{"sube", 8838},
						{"supe", 8839},
						{"oplus", 8853},
						{"otimes", 8855},
						{"perp", 8869},
						{"sdot", 8901},

						// Miscellaneous Technical
						{"lceil", 8968},
						{"rceil", 8969},
						{"lfloor", 8970},
						{"rfloor", 8971},
						{"lang", 9001},
						{"rang", 9002},

						// Geometric Shapes
						{"loz", 9674},

						// Miscellaneous Symbols
						{"spades", 9824},
						{"clubs", 9827},
						{"hearts", 9829},
						{"diams", 9830},

						{"", '\0'} };

const SMapHTMLColor cHTMLColorEntity[] = {
						{"aliceblue", 0xF0F8FF},
						{"antiquewhite", 0xFAEBD7},
						{"aqua", 0x00FFFF},
						{"aquamarine", 0x7FFFD4},
						{"azure", 0xF0FFFF},
						{"beige", 0xF5F5DC},
						{"bisque", 0xFFE4C4},
						{"black", 0x000000},
						{"blanchedalmond", 0xFFEBCD},
						{"blue", 0x0000FF},
						{"bluevoilet", 0x8A2BE2},
						{"brown", 0xA52A2A},
						{"burlywood", 0xDEB887},
						{"cadetblue", 0x5F9EA0},
						{"chartreuse", 0x7FFF00},
						{"chocolate", 0xD2691E},
						{"coral", 0xFF7F50},
						{"cornflowerblue", 0x6495ED},
						{"cornsilk", 0xFFF8DC},
						{"crimson", 0xDC143C},
						{"cyan", 0x00FFFF},
						{"darkblue", 0x00008B},
						{"darkcyan", 0x008B8B},
						{"darkgoldenrod", 0xB8860B},
						{"darkgray", 0xA9A9A9},
						{"darkgreen", 0x006400},
						{"darkkhaki", 0xBDB76B},
						{"darkmagenta", 0x8B008B},
						{"darkolivegreen", 0x556B2F},
						{"darkorange", 0xFF8C00},
						{"darkorchid", 0x9932CC},
						{"darkred", 0x8B0000},
						{"darksalmon", 0xE9967A},
						{"darkseagreen", 0x8FBC8F},
						{"darkslateblue", 0x483D8B},
						{"darkslategray", 0x2F4F4F},
						{"darkturquoise", 0x00CED1},
						{"darkviolet", 0x9400D3},
						{"deeppink", 0xFF1493},
						{"deepskyblue", 0x00BFFF},
						{"dimgray", 0x696969},
						{"dodgerblue", 0x1E90FF},
						{"firebrick", 0xB22222},
						{"floralwhite", 0xFFFAF0},
						{"forestgreen", 0x228B22},
						{"fuchsia", 0xFF00FF},
						{"gainsboro", 0xDCDCDC},
						{"ghostwhite", 0xF8F8FF},
						{"gold", 0xFFD700},
						{"goldenrod", 0xDAA520},
						{"gray", 0x808080},
						{"green", 0x008000},
						{"greenyellow", 0xADFF2F},
						{"honeydew", 0xF0FFF0},
						{"hotpink", 0xFF69B4},
						{"indianred", 0xCD5C5C},
						{"indigo", 0x4B0082},
						{"ivory", 0xFFFFF0},
						{"khaki", 0xF0E68C},
						{"lavendar", 0xE6E6FA},
						{"lavenderblush", 0xFFF0F5},
						{"lawngreen", 0x7CFC00},
						{"lemonchiffon", 0xFFFACD},
						{"lightblue", 0xADD8E6},
						{"lightcoral", 0xF08080},
						{"lightcyan", 0xE0FFFF},
						{"lightgoldenrodyellow", 0xFAFAD2},
						{"lightgreen", 0x90EE90},
						{"lightgrey", 0xD3D3D3},
						{"lightpink", 0xFFB6C1},
						{"lightsalmon", 0xFFA07A},
						{"lightseagreen", 0x20B2AA},
						{"lightskyblue", 0x87CEFA},
						{"lightslategray", 0x778899},
						{"lightsteelblue", 0xB0C4DE},
						{"lightyellow", 0xFFFFE0},
						{"lime", 0x00FF00},
						{"limegreen", 0x32CD32},
						{"linen", 0xFAF0E6},
						{"magenta", 0xFF00FF},
						{"maroon", 0x800000},
						{"mediumaquamarine", 0x66CDAA},
						{"mediumblue", 0x0000CD},
						{"mediumorchid", 0xBA55D3},
						{"mediumpurple", 0x9370D8},
						{"mediumseagreen", 0x3CB371},
						{"mediumslateblue", 0x7B68EE},
						{"mediumspringgreen", 0x00FA9A},
						{"mediumturquoise", 0x48D1CC},
						{"mediumvioletred", 0xC71585},
						{"midnightblue", 0x191970},
						{"mintcream", 0xF5FFFA},
						{"mistyrose", 0xFFE4E1},
						{"moccasin", 0xFFE4B5},
						{"navajowhite", 0xFFDEAD},
						{"navy", 0x000080},
						{"oldlace", 0xFDF5E6},
						{"olive", 0x808000},
						{"olivedrab", 0x688E23},
						{"orange", 0xFFA500},
						{"orangered", 0xFF4500},
						{"orchid", 0xDA70D6},
						{"palegoldenrod", 0xEEE8AA},
						{"palegreen", 0x98FB98},
						{"paleturquoise", 0xAFEEEE},
						{"palevioletred", 0xD87093},
						{"papayawhip", 0xFFEFD5},
						{"peachpuff", 0xFFDAB9},
						{"peru", 0xCD853F},
						{"pink", 0xFFC0CB},
						{"plum", 0xDDA0DD},
						{"powderblue", 0xB0E0E6},
						{"purple", 0x800080},
						{"red", 0xFF0000},
						{"rosybrown", 0xBC8F8F},
						{"royalblue", 0x4169E1},
						{"saddlebrown", 0x8B4513},
						{"salmon", 0xFA8072},
						{"sandybrown", 0xF4A460},
						{"seagreen", 0x2E8B57},
						{"seashell", 0xFFF5EE},
						{"sienna", 0xA0522D},
						{"silver", 0xC0C0C0},
						{"skyblue", 0x87CEEB},
						{"slateblue", 0x6A5ACD},
						{"slategray", 0x708090},
						{"snow", 0xFFFAFA},
						{"springgreen", 0x00FF7F},
						{"steelblue", 0x4682B4},
						{"tan", 0xD2B48C},
						{"teal", 0x008080},
						{"thistle", 0xD8BFD8},
						{"tomato", 0xFF6347},
						{"turquoise", 0x40E0D0},
						{"violet", 0xEE82EE},
						{"wheat", 0xF5DEB3},
						{"white", 0xFFFFFF},
						{"whitesmoke", 0xF5F5F5},
						{"yellow", 0xFFFF00},
						{"yellowgreen", 0x9ACD32},
						{"", '\0'} };
